<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_3</title>
</head>
<body>
    <h1>Capitulo 3</h1>
    <a>Ejercicio 1</a>

    <script>

    class Pila {
        constructor(n) {
            this.arr = new Array(n);
            this.size = n;
            this.top1 = Math.floor(n/3) + 1;
            this.top2 = Math.floor(n/3) + 2;
            this.top3 = Math.floor(n/3);
        }

        push1(element) {
            if (this.top1 > 0) {
                this.top1--;
                this.arr[this.top1] = element;
            } else {
                console.log(`Pila 1 llena por el elemento ${element}`);
                return;
            }
        }

        push2(element) {
            if (this.top2 > 0) {
                this.top2++;
                this.arr[this.top2] = element;
            } else {
                console.log(`Pila 2 llena por el elemento ${element}`);
                return;
            }
        }

        push3(element) {
            if (this.top3 > 0) {
                this.top3++;
                this.arr[this.top3] = element;
            } else {
                console.log(`Pila 3 llena por el elemento ${element}`);
                return;
            }
        }

        pop1() {
            if (this.top1 <= Math.floor(this.size / 3)) {
                let elem = this.arr[this.top1];
                this.top1++;
                return elem;
            } else {
                console.log("La Pila 1 esta vacia");
            }
            return 0;
        }

        pop2() {
            if (this.top2 <= Math.floor(this.size / 3) + 1) {
                let elem = this.arr[this.top2];
                this.top2--;
                return elem;
            } else {
                console.log("La Pila 2 esta vacia");
            }
            return 1;
        }

        pop3() {
            if (this.top3 <= Math.floor(this.size / 3) + 2) {
                let elem = this.arr[this.top3];
                this.top3--;
                return elem;
            } else {
                console.log("La Pila 3 esta vacia");
            }
            return 2;
        }

    }


    let ts = new Pila(9);
    ts.push1(1);    
    ts.push3(5);
    ts.push1(2);
    ts.push2(3);
    ts.push2(4);
    console.log(ts);
    ts.pop1();
    console.log(ts);




    



    </script>
    
</body>
</html>